#!/usr/bin/perl -w

# Copyright (C) 2000 Julian T. J. Midgley <jtjm@xenoclast.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# A copy of version 2 of the GNU General Public License may be found
# in the file "LICENCE" in the original Agnostos installation driectory.

use taskman_lib;
use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

my $query = new CGI;
my %config = get_config();
my $dbh = dbserver_connect(\%config);
my $table = $query -> param('table');
my $name  = $query -> param('newuser');
my ($tmpid, $tmpname, %rev_entries, $dbq);
my ($idname, $entname) = get_table($table);
my ($passwd, $passwd2);
# Select existing entries

$dbq = $dbh -> prepare("select $idname, $entname from $table");
$dbq -> execute;
while (($tmpid, $tmpname) = $dbq -> fetchrow_array) {
    $rev_entries{$tmpname} = $tmpid;
}
$dbq -> finish;

# Check for zero length or duplicate names
if ( length($name) == 0 ) {
    print error_page("Cannot enter zero length names, please go back and try again", $query);
    $dbh -> disconnect;
    exit 0;
}
if ( defined $rev_entries{$name} ) {
    print error_page("$table &quot;$name&quot; already exists; all names must be unique.", $query);
    $dbh -> disconnect;
    exit 0;
}

# If using authentication and adding a new user, check that the passwords match
# and add them to the database
if ( $config{auth_inuse} && $table eq 'user' ) {
    $passwd  = $query -> param('passwd');
    $passwd2 = $query -> param('passwd2');
    unless ($passwd eq $passwd2) {
	print error_page("Passwords don't match, please try again.",$query);
	$dbh -> disconnect;
	exit 0;
    }
    # Passwords match - add new entry
    # my $salt;
    # if $config(auth_crypt_alg eq 'MD5') {
    #	$salt = 

}

   
$dbq = $dbh -> prepare ("insert into $table ($entname) values ('$name')");
$dbq -> execute;
$dbq -> finish;


print $query -> header();
print "\n<html><head><meta name=\"pragma\" content=\"nocache\">".
      "<meta http-equiv=Refresh content=\"0; URL=name_manage.pl?table=$table\">".
      "<title>Add $table</title></head><body bgcolor=white>\n";

print "$table $name added\n";
print html_footer();

$dbh -> disconnect;
