#!/usr/bin/perl -w

# Copyright (C) 2000 Julian T. J. Midgley <jtjm@xenoclast.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# A copy of version 2 of the GNU General Public License may be found
# in the file "LICENCE" in the original Agnostos installation driectory.

use taskman_lib;
use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

my %config = get_config();
my $dbh = dbserver_connect(\%config);
my $query = new CGI;
my $table = $query -> param('table');
my ($idname, $entname) = get_table($table);
my ($dbq, %entries, $tmpid, $tmpname, $ent, @ents, @operable, $opid, $newvalue, %errors, $error);
my (%rev_entries, $html_top, @msg);
my $body  = "<ul>\n";
my $delay = 1;

$msg[0] = "Cannot truncate to zero length";
$msg[1] = "already exists";

# Select existing entries

$dbq = $dbh -> prepare("select $idname, $entname from $table");
$dbq -> execute;
while (($tmpid, $tmpname) = $dbq -> fetchrow_array) {
    $entries{$tmpid} = $tmpname;
    $rev_entries{$tmpname} = $tmpid;
}
$dbq -> finish;

# Compare new entries with the old ones, and update any that have changed.

$html_top = $query -> header();


@ents = $query -> param();

foreach $ent (@ents) {
    if ( $ent =~ /^entname_/ ) {
	push (@operable, $ent);
    }
}

foreach $ent (@operable) {
    $opid = $ent;
    $opid =~ s/^entname_//;
    $newvalue = $query -> param("$ent");
    next if ( $entries{$opid} eq $newvalue ); # Ignore names that haven't changed.
    
    # Error Checking - check for zero length names, and ensure all new names are unique 
    if ( length($newvalue) == 0 ) {
	# Can't change name to a zero length string
	$errors{$entries{$opid}} = 0;
	next;	
    }
    if ( exists $rev_entries{$newvalue} ) {
	# Name already exists;
	$errors{$newvalue} = 1;
	next;
    }
    
    Do_SQL_Query($dbh,"update $table set $entname='$newvalue' where $idname=$opid");

    $body .= "<li>Changed $entries{$opid} to $newvalue\n";

    $rev_entries{$newvalue} = $opid;      
    delete $rev_entries{$entries{$opid}}; 

}

$body .= "</ul>\n";


# Display any errors

if (%errors) {
    $delay = 5;
    $body .= "<h3>Errors:</h3>\n<ul>\n";
    foreach $error (keys %errors) {
	$body .= "<li>$error : ".$msg[$errors{$error}]."\n";
    }
    $body .= "</ul>\n";
}


# Add header (done last, so that the refresh delay can be set once we
# know whether or not there were any  errors).

$html_top .= "\n<html><head><meta http-equiv=Refresh content=\"$delay; URL=name_manage.pl?table=$table\">".
      "<title>Updating $table"."s</title></head><body bgcolor=white>\n";

print $html_top.$body;


$dbh -> disconnect;
print html_footer();

