#!/usr/bin/perl -w 


# Copyright (C) 2000 Julian T. J. Midgley <jtjm@xenoclast.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# A copy of version 2 of the GNU General Public License may be found
# in the file "LICENCE" in the original Agnostos installation driectory.

use taskman_lib;
use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);


#--------------------------------------------------------------------------
# date_select($date)
#
# Returns a HTML form object for selecting a date.  $date should be
# the number of seconds since the epoch for the default date.  If
# $date is omitted, today's date will be used.

sub
date_select
{
    my ( $date, $name, $sep, @date_format ) = @_;
    my ( $i, $day, $month, $year, @tmp, $output, $optstr, @d, @m, @y, $disabled );
    
    unless (defined $date) {
	$date = time();
    }
    @tmp   = localtime($date);
    $day   = $tmp[3];
    $month = $tmp[4]+1;
    $year  = $tmp[5]+1900;
    @d     = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31);
    @m     = (1,2,3,4,5,6,7,8,9,10,11,12);
    @y     = (2000,2001,2002,2003,2004,2005,2006,2007);

    $output = "<table border=1><tr>";
    my $daystr   = "<td><select name=".$name."_day>". 
	            optionlist( $day, @d )."</select></td>";
    my $monthstr = "<td><select name=".$name."_month>". 
                    optionlist( $month, @m )."</select></td>";
    my $yearstr  = "<td><select name=".$name."_year>".
	            optionlist( $year, @y )."</select></td>";
    $output .= format_text_date($daystr, $monthstr, $yearstr, "", @date_format);

    $output .= "</table>";
    return $output;
}

#--------------------------------------------------------------------------
# main
  
my $query = new CGI;
my %config   = get_config();
my $dbh      = dbserver_connect(\%config);
my ($start, $end);
my $tableref = get_cookie ($query);
my ($sep, @date_format) = parse_date_format(\%config);

if ( defined $$tableref{fubar} && $$tableref{fubar} eq 'completely' ) {
    print error_page ("You must select a view of a valid user from the 'Front Page' before ".
		      "it is possible to create a report",$query);
    $dbh -> disconnect;
    
    exit 0;
}

my $ent_name = get_ent_names($tableref,$dbh);


print html_header("Generate Report",$query);
print "<center>". 
      sel_table_html("Generate Report",$tableref, $dbh, \%config).
      "</center><p>\n";

print "Select the desired date range below:<br>\n";
print "<form action=weekly_report.pl method=post>\n";
print "<table><tr><td align=center><b>Start Date</b><td align=center><b>End Date</b></tr>\n";

$end = time();
$start = $end - (3600*24*8);

print "<tr><td>".date_select($start, "start", $sep, @date_format)."<td>".
                 date_select($end, "end", $sep, @date_format)."\n";
print "<tr><td><input type=submit value=Generate><td>&nbsp;</table>\n";
print "</form>\n";

print html_footer;

$dbh -> disconnect;
