#! /bin/bash

# Creates and initialises the Agnostos Database.  

# This file is modified by install.pl to create a new file
# "install_mysql_real.sh" - you shouldn't need to run either of the
# install_mysql* files by hand (install.pl takes care of that for
# you).  If you do have a good reason for wanting to run one by hand,
# then run install_mysql_real.sh, and leave this one alone, unless
# you're entirely happy with the defaults.


exit 1
DBASE_NAME=agnostos

echo -n "Creating database..."
echo "create database $DBASE_NAME" | mysql
echo "done."

echo -n "Creating tables..."
cat mysql_data/database_struct  | mysql $DBASE_NAME
echo "done."

echo -n "Initialising database..."
cat mysql_data/agnostos_inserts | mysql $DBASE_NAME
echo "done."

echo -n "Updating mysql table..."
cat mysql_data/mysql_inserts_real    | mysql mysql
echo "done."

echo -n "Reloading mysql permissions..."
mysqladmin reload
echo "done."

